hdu 4089 Activation (概率dp 手动消元)

来源:互联网 发布:剑道 自学 知乎 编辑:程序博客网 时间:2024/04/29 22:41

Activation

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1562    Accepted Submission(s): 592


Problem Description
After 4 years' waiting, the game "Chinese Paladin 5" finally comes out. Tomato is a crazy fan, and luckily he got the first release. Now he is at home, ready to begin his journey.
But before starting the game, he must first activate the product on the official site. There are too many passionate fans that the activation server cannot deal with all the requests at the same time, so all the players must wait in queue. Each time, the server deals with the request of the first player in the queue, and the result may be one of the following, each has a probability:
1. Activation failed: This happens with the probability of p1. The queue remains unchanged and the server will try to deal with the same request the next time.
2. Connection failed: This happens with the probability of p2. Something just happened and the first player in queue lost his connection with the server. The server will then remove his request from the queue. After that, the player will immediately connect to the server again and starts queuing at the tail of the queue.
3. Activation succeeded: This happens with the probability of p3. Congratulations, the player will leave the queue and enjoy the game himself.
4. Service unavailable: This happens with the probability of p4. Something just happened and the server is down. The website must shutdown the server at once. All the requests that are still in the queue will never be dealt.
Tomato thinks it sucks if the server is down while he is still waiting in the queue and there are no more than K-1 guys before him. And he wants to know the probability that this ugly thing happens.
To make it clear, we say three things may happen to Tomato: he succeeded activating the game; the server is down while he is in the queue and there are no more than K-1 guys before him; the server is down while he is in the queue and there are at least K guys before him.
Now you are to calculate the probability of the second thing.
 

Input
There are no more than 40 test cases. Each case in one line, contains three integers and four real numbers: N, M (1 <= M <= N <= 2000), K (K >= 1), p1, p2, p3, p4 (0 <= p1, p2, p3, p4 <= 1, p1 + p2 + p3 + p4 = 1), indicating there are N guys in the queue (the positions are numbered from 1 to N), and at the beginning Tomato is at the Mth position, with the probability p1, p2, p3, p4 mentioned above.
 

Output
A real number in one line for each case, the probability that the ugly thing happens.
The answer should be rounded to 5 digits after the decimal point.
 

Sample Input
2 2 1 0.1 0.2 0.3 0.43 2 1 0.4 0.3 0.2 0.14 2 3 0.16 0.16 0.16 0.52
 

Sample Output
0.304270.232800.90343
 

Source
2011 Asia Beijing Regional Contest
 

题意:
有n个人排队等着在官网上激活游戏。Tomato排在第m个。
对于队列中的第一个人。有一下情况:
1、激活失败,留在队列中等待下一次激活(概率为p1)
2、失去连接,出队列,然后排在队列的最后(概率为p2)
3、激活成功,离开队列(概率为p3)
4、服务器瘫痪,服务器停止激活,所有人都无法激活了。
求服务器瘫痪时Tomato在队列中的位置<=k的概率。

思路来源于:点击打开链接

思路:
dp[i][j]表示还有i个人,他在第j个位置达到目标状态的概率。
if(j==1)            dp[i][1]=dp[i][1]*p1+dp[i][i]*p2+p4;
if(j>=2&&j<=k)      dp[i][j]=dp[i][j]*p1+dp[i][j-1]*p2+dp[i-1][j-1]*p3+p4;
if(j>k)             dp[i][j]=dp[i][j]*p1+dp[i][j-1]*p2+dp[i-1][j-1]*p3; 
化简一下:
if(j==1)            dp[i][1]=dp[i][i]*p2/(1-p1)+p4/(1-p1);  (1)
if(j>=2&&j<=k)      dp[i][j]=dp[i][j-1]*p2/(1-p1)+dp[i-1][j-1]*p3/(1-p1)+p4/(1-p1);
if(j>k)             dp[i][j]=dp[i][j-1]*p2/(1-p1)+dp[i-1][j-1]*p3/(1-p1);

在求dp[i][j]的时候i-1的状态全部知道,只用考虑第i层,因为dp[i][1]会推到dp[i][i],所以会形成环,需要手动化简,注意i不变,所以涉及到的式子只有i个,可以迭代找出dp[i][i]与dp[i][1]的关系,然后带入(1)式,解出dp[i][i],然后就可以求dp[i][j]了。还要注意的一点是p4很小的时候概率为0。

代码:
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>#include <string>#include <map>#include <stack>#include <vector>#include <set>#include <queue>#define maxn 2005#define MAXN 400005#define mod 1000000007#define INF 0x3f3f3f3f#define pi acos(-1.0)#define eps 1e-6typedef long long ll;using namespace std;int n,m,k;double dp[maxn][maxn],p1,p2,p3,p4;void solve(){    int i,j;    double p21=p2/(1-p1),p31=p3/(1-p1),p41=p4/(1-p1),pp,tt;    dp[1][1]=p4/(1-p1-p2);    for(i=2;i<=n;i++)    {        pp=1;        tt=0;        for(j=2;j<=k&&j<=i;j++)        {            pp*=p21;            tt*=p21;            tt+=p31*dp[i-1][j-1]+p41;        }        for(j=k+1;j<=i;j++)        {            pp*=p21;            tt*=p21;            tt+=p31*dp[i-1][j-1];        }        dp[i][i]=(tt*(1-p1)+pp*p4)/(1-p1-pp*p2);        dp[i][1]=p21*dp[i][i]+p41;        for(j=2;j<=k&&j<i;j++)        {            dp[i][j]=p21*dp[i][j-1]+p31*dp[i-1][j-1]+p41;        }        for(j=k+1;j<i;j++)        {            dp[i][j]=p21*dp[i][j-1]+p31*dp[i-1][j-1];        }    }    printf("%.5f\n",dp[n][m]);}int main(){    int i,j;    while(~scanf("%d%d%d%lf%lf%lf%lf",&n,&m,&k,&p1,&p2,&p3,&p4))    {        if(p4<=eps)        {            printf("%.5f\n",0);            continue ;        }        solve();    }    return 0;}/*2 2 1 0.1 0.2 0.3 0.43 2 1 0.4 0.3 0.2 0.14 2 3 0.16 0.16 0.16 0.52*/


0 0